<?php
require_once('nusoap.php');
require_once('selectAPIoperation.config');
function pr_header() {
	
echo <<<HEADER
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
<title>HiPath DLS API test program</title>
<!--
<link rel="stylesheet" href="css/api.css" type="text/css">
-->
<meta name="description"    content="HiPath DLS API test program">
<meta name="keywords"       content="">
<meta name="author" content="Gerald Maurer, Com ESY HD 533, Siemens AG">
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<meta name="DC.Publisher"   content="Siemens AG, Com ESY HD 5">
<meta name="DC.Language"    content="en">
<meta name="DC.Date.Create" content="2006-02-24T08:00+01:00">

<!--script language="JavaScript"
		src="api.js"
        type="text/javascript">
</script-->

</head>
<body>
HEADER;
	
} // pr_header

function pr_footer() {

echo <<<FOOTER
</BODY>
</HTML>
FOOTER;

} // pr_footer

function showDynVar($level, $var) {
	$ofs = '';
	for ($i=0; $i<$level; $i++) $ofs .= '-';
	if (gettype($var) == 'array') {
		foreach ($var as $key => $value) {
			if (gettype($value) == 'array') {
				echo("$ofs $key<br />");
				showDynVar($level+1, $value);
			}
			else
				echo("$ofs $key: $value<br />");
		}
	}	
	else
		echo("$ofs $var<br />");
}

function substType($spectype) {
	global $wsdl;
								$rpos = strrpos($spectype,':');
								$searchtype = substr($spectype,0,$rpos);
								$basetype = substr($spectype,$rpos);
								if (strlen($searchtype) > 0) {
									$nt = $wsdl->getPrefixFromNamespace($searchtype);
									if (strlen($nt) == 0) $nt = $spectype;
									else $nt .= $basetype;
								}
								else {
									$nt = $spectype;	
								}
								return $nt;
	
}

function selectMessageGetType($msgvalue, $key, $value, $level) {
	global $wsdl, $params, $paramvalues, $types,
	       $currNameSpace1, $currNameSpace2, $currNameSpace3,
	       $maxArrayMembers;
	       $l0 = $l1 = '';
	       for ($i=0;$i<$level;$i++) $l0 .= '-';
	       $l1 = $l0 . '-';
					$colonpos = strrpos($value,':');
					$beanType = $wsdl->getTypeDef(substr($value,$colonpos+1),substr($value,0,$colonpos));
					$params      .= $l0." $key<br />";
					$paramvalues .= "&nbsp;<br />";
					$types       .= "&nbsp;".substType($value)."<br />";				
						if ($beanType['phpType'] == 'struct') {
							// echo(" STRUCT: $msgvalue[name]<br />");
							foreach ($beanType['elements'] as $elementname => $elementtype) {

								if (   substr($elementtype['type'],0,strlen($currNameSpace1)) == $currNameSpace1
				                    or substr($elementtype['type'],0,strlen($currNameSpace2)) == $currNameSpace2
				                    or substr($elementtype['type'],0,strlen($currNameSpace3)) == $currNameSpace3				
								   ) {
                                    selectMessageGetType($msgvalue, $elementname, $elementtype['type'], $level+1);
								}
								else
								
								{	
									$params      .= " ".$l1." ".$elementname."<br />";
									if (isset($_POST[$msgvalue['name'].$key.$elementname])) {
										$paramvalues .= "<input type=\"text\" name=\"$msgvalue[name]$key$elementname\" value=\"".$_POST[$msgvalue['name'].$key.$elementname]."\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><<br />";
									}
									else 		
										$paramvalues .= "<input type=\"text\" name=\"$msgvalue[name]$key$elementname\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";		
									
	
									//$types       .= "&nbsp;".str_replace('http://www.w3.org/2001/XMLSchema:','xsd:',$elementtype['type'])."<br />";
									//$types       .= "&nbsp;".$elementtype['type']."<br />";
									$types .= "&nbsp;".substType($elementtype['type'])."<br />";
								}				
							}
						}
						elseif ($beanType['phpType'] == 'array') {
							// echo(" ARRAY: $msgvalue[name]<br />");
							for ($ai = 0; $ai < $maxArrayMembers; $ai++) {
//							echo("[$ai] - ".$beanType['arrayType']." - $elementname - $elementtype[type]<br />" );
								
								if (   substr($beanType['arrayType'],0,strlen($currNameSpace1)) == $currNameSpace1
				                    or substr($beanType['arrayType'],0,strlen($currNameSpace2)) == $currNameSpace2
				                    or substr($beanType['arrayType'],0,strlen($currNameSpace3)) == $currNameSpace3				
								   ) {
                                    selectMessageGetType($msgvalue, "[$ai]", $beanType['arrayType'], $level+1);
								}
								else

								{								
								$params      .= " ".$l1." [$ai]<br />";
								$paramvalues .= "<input type=\"text\" name=\"$msgvalue[name]$key$ai\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";	
								$types .= "&nbsp;".substType($beanType['arrayType'])."<br />";
								}
							}
						}
						elseif ($beanType['phpType'] == 'scalar') {
							// echo(" SCALAR: $msgvalue[name]<br />");
							if (isset($_POST[$msgvalue['name'].$key])) {
								$paramvalues .= "\n<input type=\"text\" name=\"$msgvalue[name]$key\" id=\"$msgvalue[name]_".$key."\"  value=\"".$_POST[$msgvalue['name'].$key]."\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";
							}
							else {
								$paramvalues .= "\n<input type=\"text\" name=\"$msgvalue[name]$key\" id=\"$msgvalue[name]_".$key."\"  size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";
							}	
							$types .= "&nbsp;".substType($beanType['type'])."<br />";							
						}	
						else
							echo(" NEW TYPE: $msgvalue[name]: $beanType[phpType]<br />");
} // selectMessageGetType

function callCommandGetType ($cmd, $key, $value) {
	global $wsdl, $maxArrayMembers;
	echo(" $cmd $key $value<br />");
		$inpArray = array();
			$colonpos = strrpos($value,':');
			$beanType = $wsdl->getTypeDef(substr($value,$colonpos+1),substr($value,0,$colonpos));
			echo(substr($value,$colonpos+1)."=> $beantype<br />");
			if ($beanType['phpType'] == 'struct') {	
				echo(" STRUCT: $value<br />");	
				foreach ($beanType['elements'] as $elementname => $elementtype) {			
					$inpArray[$elementname] = $_POST[$cmd['name'].$key.$elementname];
					if ($debug) echo("INPUTARRAY: $cmd - $key - $elementname: $inpArray[$elementname]<br />");					
				}
			}
			elseif ($beanType['phpType'] == 'array') {
				echo(" ARRAY: $value<br />");
				for ($ai = 0; $ai < $maxArrayMembers; $ai++) {
						if (isset($_POST[$cmd.$key.$ai]) and strlen($_POST[$cmd.$key.$ai]) > 0) {
						$inpArray[$ai]      = htmlspecialchars($_POST[$cmd.$key.$ai]);
						if ($debug) echo("INPUTARRAY: $cmd - $key - $ai: $inpArray[$ai]<br />");
					}
				}
			}
			elseif ($beanType['phpType'] == 'scalar') {
				echo(" SCALAR: $value<br />");
				if ($debug) echo("INPUT: $cmd - $key: ".$_POST[$cmd.$key]."<br />");
				return $_POST[$cmd.$key];
			}
			else echo("TYPE ".$beanType['phpType']." not yet implemented<br />");
	return $inpArray;
				
} // callCommandGetType

function show_available_messages () {
	global $wsdl, $servicename, $apiversion;
	$operations = array();
	$operations = $wsdl->getOperations();
	asort($operations);
	echo("<h2>available operations for $servicename version $apiversion</h2>" .
			"<table border=\"1\" summary=\"operations for $servicename version $apiversion\">" .
			"<tr><th>operation</th><th>parameter</th><th>type</th></tr>");
	$cmp = "";
	foreach ($operations as $message => $msgvalue) {
//		foreach ($msgvalue['input']['parts'] as $key => $value) {
			if ($msgvalue['name'] == $cmp) {
				echo("<tr><td id=\"$cmp\"></td><td id=\"$cmp\">$key</td><td id=\"$cmp\">".substType($value)."</td></tr>");
			}
			else {
				$cmp = $msgvalue['name'];
				echo("<tr><td>$msgvalue[name]</td><td id=\"$cmp\">$key</td><td id=\"$cmp\">".substType($value)."</td></tr>");

			}
//		}	
	}
	echo("</table>");
} // show_available_messages

function select_message() {
	global $operations, $servicename, $server, $wsdl, $useSession, $sessionToken;
	global $params, $paramvalues, $types, $currNameSpace1, $currNameSpace2, $currNameSpace3;
	

	echo("<h3>available operations for service $servicename on server $server</h3>" .
		 "<form id=\"operations\" action=\"$_SERVER[PHP_SELF] \" method=\"post\" >" .
		 "<table border=\"0\" summary=\"available operations for service $servicename on server $server\">");
/*	
	echo("<tr><th style=\"text-align:left\">operation / parameter name(s)</th>" .
				"<!--<th style=\"text-align:left\">parameter name</th>-->" .
				"<th style=\"text-align:left\">&nbsp;value</th>" .
				"<th style=\"text-align:left\">&nbsp;type</th>" .
				"<th style=\"text-align:left\">&nbsp;submit</th></tr>");
*/
	echo("<tr><td colspan=\"4\"><hr /></td></tr>");

	foreach ($operations as $message => $msgvalue) {			
		$params      = "<div id=\"params$msgvalue[name]\" style=\"line-height:150%\">";
		$paramvalues = "<div id=\"paramvalues$msgvalue[name]\" style=\"line-height:150%\">";
		$types       = "<div id=\"types$msgvalue[name]\" style=\"line-height:150%\">";
		$i=0; $j=0;
		foreach ($msgvalue['input']['parts'] as $key => $value) {
			$i++;
			
			if ($key == "inputBean") {
				echo("inputBean<br />");
				$params      .= "$key <br />";
				$colonpos = strrpos($value,':');
				$beanType = $wsdl->getTypeDef(substr($value,$colonpos+1),substr($value,0,$colonpos));
				$paramvalues .= "&nbsp;<br />";
				$types       .= "&nbsp;".substType($value)."<br />";				
					foreach ($beanType['elements'] as $elementname => $elementtype) {			
						if (substr($elementtype['type'],0,strlen($currNameSpace1)) == $currNameSpace1) {
							selectMessageGetType($msgvalue, $elementname, $elementtype['type'],0);
						}
						elseif (substr($elementtype['type'],0,strlen($currNameSpace2)) == $currNameSpace2) {
							selectMessageGetType($msgvalue, $elementname, $elementtype['type'],0);
						}
						elseif (substr($elementtype['type'],0,strlen($currNameSpace3)) == $currNameSpace3) {
							selectMessageGetType($msgvalue, $elementname, $elementtype['type'],0);
						}
						
						else {
							$params      .= " - ".$elementname."<br />";
							if (isset($_POST[$msgvalue['name'].$key.$elementname])) {
								$paramvalues .= "<input type=\"text\" name=\"$msgvalue[name]$key$elementname\" value=\"".$_POST[$msgvalue['name'].$key.$elementname]."\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";
							}
							else 		
								$paramvalues .= "<input type=\"text\" name=\"$msgvalue[name]$key$elementname\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";		
							$types       .= "&nbsp;".substType($elementtype['type'])."<br />";
						}				
					}
			}
			else {
				if ($key == SESSIONTOKENPARAMNAME) {
				
					$params      .= "$key <br />";
					$paramvalues .= "\n<input type=\"text\" name=\"$msgvalue[name]$key\" id=\"$msgvalue[name]_".$key."\"  value=\"".$sessionToken."\" size=\"50\" maxlength=\"1000\" onXX=\"sendExecute(event);\" /><br />";
					$types       .= "&nbsp;".substType($value)."<br />";
				}
				elseif (substr($value,0,strlen($currNameSpace1)) == $currNameSpace1) {
//					echo("SELECT1 $value<br />");
					selectMessageGetType($msgvalue, $key, $value,0);
				}			
				elseif (substr($value,0,strlen($currNameSpace2)) == $currNameSpace2) {
					echo("SELECT2 $value<br />");
//					selectMessageGetType($msgvalue, $key, $value,0);
				}
				elseif (substr($value,0,strlen($currNameSpace3)) == $currNameSpace3) {
//					echo("SELECT3 $value<br />");
					selectMessageGetType($msgvalue, $key, $value,0);
				}			
				elseif (isset($_POST[$msgvalue['name'].$key])) {
					$params      .= "$key <br />";
					$paramvalues .= "\n<input type=\"text\" name=\"$msgvalue[name]$key\" id=\"$msgvalue[name]_".$key."\"  value=\"".$_POST[$msgvalue['name'].$key]."\" size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";
					$types       .= "&nbsp;".substType($value)."<br />";
				}
				else {
					$params      .= "$key <br />";
					$paramvalues .= "\n<input type=\"text\" name=\"$msgvalue[name]$key\" id=\"$msgvalue[name]_".$key."\"  size=\"50\" maxlength=\"255\" onXX=\"sendExecute(event);\" /><br />";
					$types       .= "&nbsp;".substType($value)."<br />";
				}
			}
		}	
		$params .= "</div>"; $paramvalues .= "</div>"; $types .= "</div>";
		if ($i == 0) {
			echo("<tr><td style=\"vertical-align:top\" id=\"tdparam$msgvalue[name]\" colspan=\"3\"><a name=\"$msgvalue[name]\"><b>$msgvalue[name]</b></a></td>" .
					 "<td style=\"vertical-align:bottom\"><div id=\"exec$msgvalue[name]\">" .
				     	"<input type=\"submit\" name=\"submit$msgvalue[name]\" value=\"execute\" /></div></tr>");						
		}
		else {
			echo("<tr><td style=\"vertical-align:top\" id=\"tdparam$msgvalue[name]\" colspan=\"4\"><a name=\"$msgvalue[name]\"><b>$msgvalue[name]</b></a></td></tr>" .
				 "<tr><td><table><tr><td>&nbsp;</td><td>$params</td></tr></table></td>" .
					 "<td>$paramvalues</td>" .
					 "<td>$types</td>" .
					 "<td style=\"vertical-align:bottom\"><div id=\"exec$msgvalue[name]\">" .
				     	"<input type=\"submit\" id=\"submit$msgvalue[name]\" name=\"submit$msgvalue[name]\" value=\"execute\" /></div></tr>");
		}
		echo("<tr><td colspan=\"4\"><hr /></td></tr>");
	}
	echo("</table></form>");
} // select_message

function show_result() {
	global $resproxy;
	
	echo("<br /><h3>Response</h3>");
	if (gettype($resproxy) == 'array') {
		foreach($resproxy as $key1 => $value1) {
	  		echo("-------------------------------------<br />");
	  		if (gettype($value1) == 'array') {
	  			foreach($value1 as $key2 => $value2) {
	  				if (gettype($value2) == 'array') {
	  					foreach($value2 as $key3 => $value3)
  							echo("$key1 => $key2 => $key3 => $value3 <br />");
	  				}
	  				else {
	  					echo("$key1 => $key2 => $value2 <br />");
	  				}	
	  			}
	  		}
	  		else {
	  			echo("$key1 => $value1<br />");
	  		}
		}
	}
	else
		echo("$resproxy<br />");
} // show_result

function checkResponse()  {
	global $proxy, $resproxy;
	
	if ($proxy->fault) {
		echo '<h2>Fault</h2><pre>';
		print_r($resproxy);
		echo '</pre>';
		return false;
	} else {
		// Check for errors
		$err = $proxy->getError();
		if ($err) {
			// Display the error
			echo '<h2>Error</h2><pre>' . $err . '</pre>';
			return false;
		} else {
			return true;
		}
	}	
} // checkResult

function checkPostData() {
	global $operations;
//	foreach($_POST as $k => $v) echo("POST: $k: $v<br />");
	foreach ($operations as $msgvalue) {
		if 	(isset($_POST["submit$msgvalue[name]"])) return $msgvalue['name'];
	}	
} // checkPostData

function call_command($cmd) {
	global	$proxy, $client, $resproxy, $operations, $currNameSpace1, $currNameSpace2, $currNameSpace3,
			$debug, $wsdl, $sessionToken, $sessionTokenAuto;
	
	$cp = array();
	$i = 0;
	$callcmd = "\$resproxy = \$proxy->$cmd(";

	foreach ($operations[$cmd]['input']['parts'] as $key => $value) {
		$i++; 
		if ($key == 'sessionToken' and $sessionTokenAuto) {
			$cp[$i] = $sessionToken;
			if ($debug) echo("param $i: $cp[$i]<br />");
		}
		elseif ($key == 'inputBean') {
			$inpBean = array();
			//echo("$cmd.$key => $value<br />");
			$colonpos = strrpos($value,':');
			$beanType = $wsdl->getTypeDef(substr($value,$colonpos+1),substr($value,0,$colonpos));
			foreach ($beanType['elements'] as $elementname => $elementtype) {
				if (substr($elementtype['type'],0,strlen($currNameSpace1)) == $currNameSpace1) {
					//echo("test2<br />");
					$inpBean = callCommandGetType($cmd, $elementname, $elementtype['type']);
				}
				if (substr($elementtype['type'],0,strlen($currNameSpace2)) == $currNameSpace2) {
					//echo("test2<br />");
					$inpBean = callCommandGetType($cmd, $elementname, $elementtype['type']);
				}
				if (substr($elementtype['type'],0,strlen($currNameSpace3)) == $currNameSpace3) {
					//echo("test2<br />");
					$inpBean = callCommandGetType($cmd, $elementname, $elementtype['type']);
				}
				else {
					$inpBean[$elementname] = htmlspecialchars($_POST[$cmd.$key.$elementname]);
					echo("$cmd$key$elementname => $elementtype[type] - ".$_POST[$cmd.$key.$elementname]."<br />");
					//if ($debug) echo("param $i: inputBean.$elementname: $inpBean[$elementname]<br />");
				}
			}
			$cp[$i] = $inpBean;
			if ($debug) echo("PARAM $i: ".$cp[$i]."<br />");
			if ($debug) foreach ($cp[$i] as $paramkey => $paramvalue) echo("- $paramkey => $paramvalue<br />");
		}
		elseif (substr($value,0,strlen($currNameSpace1)) == $currNameSpace1
		        OR substr($value,0,strlen($currNameSpace2)) == $currNameSpace2
		        OR substr($value,0,strlen($currNameSpace3)) == $currNameSpace3
		       ) {
			//echo("test1<br />");
			$cp[$i] = callCommandGetType($cmd, $key, $value);
			if ($debug) echo("PARAM $i: ".$cp[$i]."<br />");
			if ($debug) if (gettype($cp[$i]) == 'array') foreach ($cp[$i] as $paramkey => $paramvalue) echo("- $paramkey => $paramvalue<br />");
		}
		elseif (isset($_POST[$cmd.$key]))  {
			
			$cp[$i] = htmlspecialchars($_POST[$cmd.$key]);
			if ($debug) echo("PARAM $i: $cp[$i]<br />");
		}
		$callcmd .= "\$cp[$i],";
	}
	if ($i>0) {
		$callcmd = substr($callcmd,0,strlen($callcmd)-1);
	}
	$callcmd .= ");";

	eval($callcmd);

	if (checkResponse()) {
		echo("<h3>Result of $cmd</h3>");
		showDynVar(0,$resproxy);
		/*
		echo("<pre>");
		print_r(str_replace('><',">\n<", $proxy->response));
		echo("</pre>");
		*/
	}
	
} // call_command


$wsdl = new wsdl($wsdlUrl);
$operations = array();
$operations = $wsdl->getOperations();
asort($operations);
$start = strrpos($wsdlUrl, '/');
$stop = strrpos($wsdlUrl, '?');
$servicename = substr($wsdlUrl,$start+1,$stop-$start-1);
$start = strpos($wsdlUrl, '//');
$stop = strrpos($wsdlUrl, ':8080');
$server = substr($wsdlUrl,$start+2,$stop-$start-2);

pr_header();

$client = new nusoapclient( $wsdlUrl, true);

$err = $client->getError();
if ($err) {
	// Display the error
	echo("<h2>Constructor error on server $server</h2><pre>" . $err . "</pre>");
	// At this point, you know the call that follows will fail	
	pr_footer(); exit();
}	 

$proxy = $client->getProxy();
//$classcode = $client->getProxyClassCode();
//echo("<pre>$classcode</pre><br /><br />");

if ($useSession) {
	if (isset($_POST[SESSIONTOKENPARAMNAME]))
		$sessionToken = $_POST[SESSIONTOKENPARAMNAME];
	else
		$sessionToken = '';
}
else {
	$sessionTokenResp = $proxy->openSession($username, $password);
	if (!checkresponse()) { pr_footer(); exit(); }
	$sessionToken = $sessionTokenResp['result'];
}
 $resproxy = $proxy->getApiServerVersionString();
 if (checkResponse()) $apiversion = $resproxy;	else 
	 $apiversion = 'not available';

echo("<a name=\"top\">working with server $server and API version $apiversion</a><br />");


// check selected command
$cmd = checkPostData();
if ($cmd != "") {
	if ($useSession and $sessionToken == "" ) $sessionToken = $_POST[$cmd.SESSIONTOKENPARAMNAME];
//	echo("SessionToken: ".$_POST[$cmd.SESSIONTOKENPARAMNAME]."<br />"); 
	echo("skip to <a href=\"#$cmd\">$cmd operation</a>");
	if ($debug) echo("&nbsp;&nbsp;<a href=\"#request\">request</a>&nbsp;&nbsp;<a href=\"#response\">response</a>&nbsp;&nbsp;<a href=\"#debug\">debug</a>&nbsp;&nbsp;<a href=\"#bottom\">bottom</a>");
	echo("<br />");
	switch ($cmd) {
	case "specialAPIcommand":
		// insert special handling for 'specialAPIcommand'
		break;
	default:
		echo("operation <b>$cmd</b> not explicitely implemented in test program<br />");
		call_command($cmd);
	}
}

//show_available_messages();
select_message();

//$resproxy = $proxy->isValidApiVersion($apiversion);
//if (checkResponse() and $resproxy == 1) echo("valid API version used<br />");


if ($debug) {
	echo("<h2><a name=\"request\">Request</a></h2><pre>" .htmlspecialchars(str_replace('><',">\n<", $proxy->request), ENT_QUOTES) . "</pre>skip <a href=\"#top\">top</a>");
	echo("<h2><a name=\"response\">Response</a></h2><pre>" .htmlspecialchars(str_replace('><',">\n<", $proxy->response), ENT_QUOTES) . "</pre>skip <a href=\"#top\">top</a>");
//	echo("<h2><a name=\"debug\">Debug</a></h2><pre>" . htmlspecialchars($proxy->debug_str, ENT_QUOTES) . "</pre><a name=\"bottom\">skip </a><a href=\"#top\">top</a>");
}
if (!$useSession) $proxy->closeSession($sessionToken);
if ($debug) {
//	echo("<h2><a name=\"request\">Request</a></h2><pre>" .htmlspecialchars(str_replace('><',">\n<", $proxy->request), ENT_QUOTES) . "</pre>skip <a href=\"#top\">top</a>");
//	echo("<h2><a name=\"response\">Response</a></h2><pre>" .htmlspecialchars(str_replace('><',">\n<", $proxy->response), ENT_QUOTES) . "</pre>skip <a href=\"#top\">top</a>");
	echo("<h2><a name=\"debug\">Debug</a></h2><pre>" . htmlspecialchars($proxy->debug_str, ENT_QUOTES) . "</pre><a name=\"bottom\">skip </a><a href=\"#top\">top</a>");
}
pr_footer();
?>

